# 4.0.2

## Added

* Added Header-based DRM certificate and license request (4038)
* Added support for SPM (3998)
* Expose playback stats (4039)
* Added support for Cleark Key contents (3949)
* Added license modifiers (4042)

## Changed

* Separated `AirPlay` mirroring and streaming for Subtitles plugin (4031)
* Exposed `bufferedPercentage` property in DASH contents (4017)
* Removed the HLS download task once it is completed (4030)
* Aligned state transition with the state graph (4007)

# 4.0.1

## Added

* Added `MacCatalyst` support for Intel CPUs (3980)
* Added error reporting for `stalled` and `failed` playbacks (3987)
* Added dedicated error resource unavailable `.player_resource_unavailable` (3242)
* Added dedicated warning for `Internet Connection` availability (3678)
* Added new parameter to `register()` method for setting companion sdk name and version (4041)

## Changed

* Exposed `Broadpeak` configuration options (3922)
* Added `parallel download` demo (3944)
* Fixed download UI error in `PlaymakerApp` (2023)
* `Apple TV` player, synchronize state on the main thread (3999)
* Fixed selection of audio and video renditions (3996)
* Made `.error` player state final (4015)
* Improved and unified plugins and SDK versions (4016)
* Fixed `preferredAudioLanguage` for HLSPlayer (4012)
* Improved the playback state transitions (4002)
* Exposed `bufferedPercentage` property in HLS contents (4013)
* Improved the grid thumbnail initializer (4009)
* Updated `changeIndex` for waiting playback preconditions (ads preroll, Broadpeak) (4022)

# 4.0.0

## Changed

* Merged `CastlabsVT` plugin with `CastlabsWidevine` (3862)
* Improved internal error handling (3863)
* Fixed `Chromecast` tracks mapping (3943)
* Improved `Public API` error reporting (3314)
* Fixed `onCurrentTime` rate calling in `Public API` (3942)
* Added example project showcasing support for Mac with Apple Silicon (2506)
* Clarify differences between `TTML`, `IMSC1` and `SMPTE-TT` in documentation (3913)
* Improved `SubtitlesAPI` and `CastlabsSubtitles` plugin synchronisation (3920)
* Fixed playback not finish instantly when scrolling to the end in `VTPlayer` (3915)
* Fixed playback for content using `DRMToday Onboard` (3722)
* Made request and response modifiers asynchronous (3927)
* Improved internal components communication and synchronisation (3947)
* Added error reporting to `CastlabsYoubora` (3929)
* Built and included `YouboraLib` as dynamic XCFramework (3903)
* Added missing requests in the Youbora plugin (3928)
* Fixed AD session is not released properly (3926)
* Improved `PlayerWrapper` callbacks storing (3946)
* Fixed Airplay fails for FPS with Auth token (2900)
* Exposed response type in `ResponseModifier` (3938)
* Changed product name from `PRESTOPlay` to `PRESTOplay` (3939)
* AD sessions are now reported to Conviva (3941, 3945)
* Conviva demos now correctly report sessions to Conviva (3963)
* Improved overall documentation (2992)
* Fix playback for protected HLS content (3961)
* Downloaded DASH contents now play correctly in airplane mode (3265)
* AD events are no longer sent to Youbora when ads are disabled (3962)
* Downloading DRM contents works in `PlaymakerApp` (3630)
* Revised and improved the documentation for the demos (3971)
* Allowed insecure connection for `BroadpeakDemo` (3965)
* IMA Ads menu in Demos project now displays ads correctly (3972)
* Fixed playback loop (3820)
* Added status code to network response modifier (3952)
* Added Widevine CDM to the SDK package (3967)
* Fixed Fairplay rental license storage (3919)
* Improved synchronization of player properties (3951)
* Fixed `HLSDownloader` track selection (3916)
* Improved error handling for Chromecast (3957)
* Fixed sideloaded thumbnails (3973)
* Ads now display properly in clear DASH contents (3984)
* Added network path monitor to the system component (3976)
* Renamed Conviva parameter names (3966)

# 4.0.0-rc6

## Changed

* Fixed playback error in Demos project (3849)
* Fixed session release issue (3847)
* Improved IMSC1 embedded subtitles tracks support (3866)
* Fixed release issues in the replacement method (3874)
* Fixed sideloaded subtitles track initialization and selection (3858)
* Fixed playback state is not updated (3887)
* Updated grid thumbnail initializer (3890)
* Added Conviva plugin example (3688)
* Expose chromecast media status in CastAPI (3891)
* Implemented default phone call handler (3744)
* Fixed playback not paused while ad playing (3894)
* Fixed playback failed after post-roll ad (3901)
* Made YouboraLib linked statically to `CastlabsYoubora` plugin (3778)
* Fixed FPS license request cancellation (3905)
* Added `CastlabsIMA.xcframework` to the release plugin and updated IMA demo (3691)
* Fixed VTPlayer playback issues with ad (3912)

# 4.0.0-rc5

## Changed

* Added `replace(config:)` method to `PlayerComponentProtocol` (3802)
* Added `CastlabsDASHDemo` example and update the Demos project (3693)
* Added `BroadpeakDemo` example and update the Demos project (3686)
* `TVPlayerViewController` supports iOS and is renamed to `ApplePlayerViewController` (3770)
* Improved Downloads removal for DASH and HLS streams (3736)
* Updated `CastlabsWidevine` documentation (3694)
* Updated `CastlabsVT` documentation (3692)
* Updated Broadpeak version to `04.05.03.380e6d2` (3884)
* Fixed requesting media data when a DASH stream is played to the end (2901)
* Improved track model by including media characteristics (3851)

# 4.0.0-rc4

## Changed

* Bumped minimum deployment target to 13.0 for all SDK and Plugins
* Bumped `Google Cast SDK`` for iOS to version 4.8.0
* Added `CastlabsVT.xcframework` to the release plugin (3789)
* Added `CastlabsWidevine.xcframework` to the release plugin (3795)
* Fixed DRM system selection for automatic value

# 4.0.0-rc3

## Changed

* Expose `getLiveStartTime` in PlayerViewControllerAPI. (3788)
* Fixed `seekableTimeRanges` returning wrong value. (3785)

# 4.0.0-rc2

## Changed

* Apple TV player, use PlayerAPI instance in TVPlayerViewController. (3536)
* Apple TV player, support analytic plugins. (3536)
* Apple TV player, expose the audio and subtitle track change event and api. (3674)
* Apple TV player, add onError() event and pass error code and message. (3666, 3668)
* Apple TV player, add an option to disable channel skipping in live stream. (3658)
* Fixed player returning incorrect track value. (3772)
* Expose `getLiveStartTime` for live content. (3750)
* Fixed random crash during a seek operation. (3747)
* Fixed player events spam. (3726)

# 4.0.0-rc1

## Changed

* Rewritten CastlabsApple plugin
* Rewritten CastlabsThumbnails plugin
* Rewritten CastlabsSubtitles plugin
* Rewritten CastlabsDownloader plugin
* Rewritten CastlabsChromecast plugin
* Rewritten CastlabsYoubora plugin
* Prepared for React Native integration
* Added Migration Guide from v3 to v4
* Updated examples and demos
* Updated documentation

# 4.0.0-beta20230524

## Changed

* Added track-change flag to PlayerState. (3605)
* Added http status code and uri to error data. (3662)
* Apple TV player, can use system image for action buttons. (3661)
* Support `liveConfiguration.liveEdgeLatencyMs` player configuration in HLS player and TVPlayerViewController. (3584)
* Fixed thumbnails directory is not created on tvOS device. (3676)

# 4.0.0-beta20230420

## Changed

* Apple TV player, added channel flipping protocols. (3597, 3624)
* Apple TV player, removed `eventName` from action info. (3609)
* Apple TV player, added `getCurrentTime()` method. (3618)
* Apple TV player, added `requiresLinearPlayback` option. (3619)
* Apple TV player, fixed playback continues when player closed. (3639)
* Downloader, added HLS media downloader support. (3375)

# 4.0.0-beta20230308

## Changed

* Added seek and playback status events to Apple TV player. (3601)
* Set analytics player name to CastlabsPlayer. (3554)
* Fixed app crashes when the license key is not valid. (3589)
* Fixed not seek accurately to time 00:00. (3567)
* Fixed `contentType:HLS` is not supported in PlayerConfiguration json. (3593)
