//
//  AppDelegate.swift
//  Demos
//
//

import PRESTOplay
import CastlabsApple
#if !os(tvOS)
import CastlabsChromecast
import CastlabsDownloader
#endif
import CastlabsSubtitles
import CastlabsThumbnails
import CastlabsYoubora
import CastlabsBroadpeak
import CastlabsConviva
import CastlabsVT
import CastlabsIMA
import UIKit
import AVFoundation
import SwiftUI

@main
class AppDelegate: UIResponder, UIApplicationDelegate {
    var window: UIWindow?

    func application(
        _: UIApplication,
        didFinishLaunchingWithOptions _: [UIApplication.LaunchOptionsKey: Any]?)
        -> Bool
    {
        let youboraSettings = YouboraSettings(accountCode: "")

        let broadpeakSettings = BroadpeakSettings(
            analyticsAddress: "YOUR-ANALYTICS-SERVER-ADDRESS",
            nanoCDNHost: "",
            domainNames: "")

        let convivaSettings = ConvivaSettings(
            customerKey: "YOUR-CUSTOMER-KEY",
            gatewayUrl: "YOUR-GATEWAY-URL")

        let plugins: [CLPluginProtocol] = [
            HLSPlugin(),
            VTPlugin(),
            SubtitlesPlugin(),
            ThumbnailsPlugin(),
            YouboraPlugin(youboraSettings),
            BroadpeakPlugin(broadpeakSettings),
            ConvivaPlugin(convivaSettings),
            IMAPlugin(),
        ]

        _ = PRESTOplaySDK.shared.register(
            "LICENSE",
            plugins
        )

        try? AVAudioSession.sharedInstance().setCategory(.playback)

        window = UIWindow(frame: UIScreen.main.bounds)
        window?.rootViewController = UIHostingController(rootView: DemosView(demos: []))
        window?.makeKeyAndVisible()
        return true
    }
}
